*
      SUBROUTINE PAR_GESV(NAME, N, NPROCS, MMIN, NB, NPROW, NPCOL)
*
*        NB,   (NPROW,NPCOL)  
*          
*     PDGESV, PDGESV1, PDGESV2, PDGESV3
*
*  
      INTEGER            N, NPROCS, MMIN, NB, NPROW, NPCOL
      CHARACTER*(*)   NAME, TRANS
*
*   -  
      INTEGER           NPR
      PARAMETER         (NPR = 6, TRANS='N')
*
*  
      INTEGER            I, IPA, IPB, IPX, IPW, IPPIV, NPROCS1,
     $                   LCM, LCMQ,  MXNP, MXNQ, NQB, NQRHS,
     $                   NRHS, NBRHS, NB0, WORKSIZ,
     $                   LWORK, LIWORK
*
*  
      INTEGER            ICEIL, ILCM, NUMROC
      EXTERNAL           ICEIL, ILCM, NUMROC
*
*  
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = INT(SQRT(REAL(NPROCS)))
      NPCOL = NPROCS/NPROW
*
      IF( NB .NE. 0 ) GO TO 5
      IF( NPROCS .LT. N ) GO TO 9
      WRITE(NPR, FMT = *)' NPROCS .GE. N ! (  NPROCS !! )'
      GO TO 10
    9 NB0 = INT(REAL( N/MAX(NPROW,NPCOL) ))
      IF( NB0.LT.4 ) NB = 2
*1      NB0 = INT(REAL( N/NPROW) )
*1      IF( NB0.LT.4 ) NB = NB0
      IF( NB0.GE.4 .AND. NB0.LT.8 ) NB = 4
*
      IF( NB0.GE.8 .AND. NB0.LT.16 ) NB = 8
      IF( NB0.GE.16 .AND. NB0.LT.32 ) NB = 16
      IF( NB0.GE.32 ) NB = 32
*
*      IA=JA=IB=JB=IX=JX=IAF=JAF= 1
    5 NRHS = 1
      NBRHS = 1
      NQRHS = 1
*
      MXNP = NUMROC( N, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      MXLLDA = MXNP
      MXLLDB = MXLLDA
*
*     A
      IPA = 1
*
*    ()   B
      IPB = IPA + MXLLDA*MXNQ
*
*      
*   
*
      IPPIV = IPB + MXLLDB*NQRHS
      LIPIV = ICEIL( 4*(MXNP+NB), 8 )
      IPW = IPPIV + MAX( MXNP, LIPIV )
*
      IF( NAME .NE. 'PDGESV3' ) GOTO 1
*
      IPAF = IPPIV + MAX( MXNP, LIPIV )
      IPX = IPAF + MXLLDA*MXNQ
*
      IPFER = IPX + MXLLDB*NQRHS
      IPBER = IPFER + MXLLDB*NQRHS
      IPWOR = IPBER + MXLLDB*NQRHS
*
      NQB = ICEIL( N, NB*NPCOL )
      LCM = ILCM( NPROW, NPCOL )
      LCMQ = LCM / NPCOL
*
*   ,    PDGESV3
*
      LWORK = 4*MXNP + MXNQ + ICEIL(NQB, LCMQ)*NB
      LIWORK = MXNP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
*
      GO TO 3
*
    1 IF( NAME .NE. 'PDGESV2' ) GOTO 7
*
      IPWOR =IPPIV + MAX( MXNP, LIPIV )
*
*   ,    PDGESV2
*
      LWORK = 2*MXNP + 2*MXNQ
     $       + MAX(2, MAX(NB*MAX(1, ICEIL(NPROW-1, NPCOL)),
     $                   MXNQ + NB*MAX(1, ICEIL(NPCOL-1, NPROW))))
      LIWORK = MXNP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GOTO 3
    7 IF( NAME .NE. 'PDGESV' .AND. NAME .NE. 'PDGESV1') GOTO 10
          GO TO 3
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, MXNP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NPROCS
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
         WRITE( NPR, FMT = 9993 )NB, NB
         WRITE( NPR, FMT = * )'    IPA,    IPB,   IPPIV,  IPW,   MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPB, IPPIV, IPW, MMIN
         IF( NAME .NE. 'PDGESV3' ) GOTO 2
         WRITE( NPR, FMT = * )'   IPAF,   IPX, IPFER,   IPBER, IPWOR'
         WRITE( NPR, FMT = 9994 )IPAF, IPX, IPFER, IPBER, IPWOR
    2   CONTINUE
*
 9994 FORMAT( / 5I9 /)
 9985 FORMAT( / 9I5 /)
*
   10 CONTINUE
*
 9992 FORMAT( / '      A X = B',
     $      '    ', A7/ )
 9998 FORMAT( /'     A ',I5,' *',I5,',',
     $       '    ',I3 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I3, ' *', I3, ';' /
     $      '      '/
     $      '    ',
     $      I9,'  '/)
 9993 FORMAT( / '       NB ',
     $       I3,' *',I3 // '     '/)
      RETURN
      END
